<html>
<head>
<title>OGRE: OgreQuaternion.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreQuaternion.h</h1><a href="OgreQuaternion_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">// NOTE THAT THIS FILE IS BASED ON MATERIAL FROM:</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Magic Software, Inc.</span>
<a name="l00032"></a>00032 <span class="comment">// http://www.geometrictools.com/</span>
<a name="l00033"></a>00033 <span class="comment">// Copyright (c) 2000, All Rights Reserved</span>
<a name="l00034"></a>00034 <span class="comment">//</span>
<a name="l00035"></a>00035 <span class="comment">// Source code from Magic Software is supplied under the terms of a license</span>
<a name="l00036"></a>00036 <span class="comment">// agreement and may not be copied or disclosed except in accordance with the</span>
<a name="l00037"></a>00037 <span class="comment">// terms of that agreement.  The various license agreements may be found at</span>
<a name="l00038"></a>00038 <span class="comment">// the Magic Software web site.  This file is subject to the license</span>
<a name="l00039"></a>00039 <span class="comment">//</span>
<a name="l00040"></a>00040 <span class="comment">// FREE SOURCE CODE</span>
<a name="l00041"></a>00041 <span class="comment">// http://www.geometrictools.com/License/WildMagic3License.pdf</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#ifndef __Quaternion_H__</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#define __Quaternion_H__</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include "<a class="code" href="OgreMath_8h.html">OgreMath.h</a>"</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>Ogre {
<a name="l00050"></a>00050 
<a name="l00053"></a><a class="code" href="classOgre_1_1Quaternion.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">public</span>:
<a name="l00056"></a><a class="code" href="classOgre_1_1Quaternion.html#dd13bf39aaf6300299354acc87a23025">00056</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> (
<a name="l00057"></a>00057             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fW = 1.0,
<a name="l00058"></a>00058             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX = 0.0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY = 0.0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ = 0.0)
<a name="l00059"></a>00059         {
<a name="l00060"></a>00060             w = fW;
<a name="l00061"></a>00061             x = fX;
<a name="l00062"></a>00062             y = fY;
<a name="l00063"></a>00063             z = fZ;
<a name="l00064"></a>00064         }
<a name="l00065"></a><a class="code" href="classOgre_1_1Quaternion.html#2cffcbdf2862e0f76ea1bffc89f7122a">00065</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ)
<a name="l00066"></a>00066         {
<a name="l00067"></a>00067             w = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#f3424f1e07092c0ffe293d18b277a04f">w</a>;
<a name="l00068"></a>00068             x = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#32c5680516b41bc4ba3159bf4d4abaf1">x</a>;
<a name="l00069"></a>00069             y = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#a7328cd3883a92ee9c9322805d038f11">y</a>;
<a name="l00070"></a>00070             z = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#31ec84a931236554c0c17e37bf5ace97">z</a>;
<a name="l00071"></a>00071         }
<a name="l00073"></a><a class="code" href="classOgre_1_1Quaternion.html#cdcb70a4f122452b6fa70d7cf5ce3cf3">00073</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rot)
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075             this-&gt;FromRotationMatrix(rot);
<a name="l00076"></a>00076         }
<a name="l00078"></a><a class="code" href="classOgre_1_1Quaternion.html#7f25c623d95186b58f6367dcd097a5ba">00078</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             this-&gt;FromAngleAxis(rfAngle, rkAxis);
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 <span class="preprocessor">#ifndef OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>        <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             this-&gt;FromAngleAxis(rfAngle, rkAxis);
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087 <span class="preprocessor">#endif//OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00089"></a><a class="code" href="classOgre_1_1Quaternion.html#1140011dc0793a81c55f2d078c8c964c">00089</a> <span class="preprocessor">        inline Quaternion(const Vector3&amp; xaxis, const Vector3&amp; yaxis, const Vector3&amp; zaxis)</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>        {
<a name="l00091"></a>00091             this-&gt;FromAxes(xaxis, yaxis, zaxis);
<a name="l00092"></a>00092         }
<a name="l00094"></a><a class="code" href="classOgre_1_1Quaternion.html#3ccc60338011887023b397a02a7f3336">00094</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* akAxis)
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096             this-&gt;FromAxes(akAxis);
<a name="l00097"></a>00097         }
<a name="l00099"></a><a class="code" href="classOgre_1_1Quaternion.html#1ca81bd9d57e43cf23582c898e5fdd34">00099</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* valptr)
<a name="l00100"></a>00100         {
<a name="l00101"></a>00101             memcpy(&amp;w, valptr, <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*4);
<a name="l00102"></a>00102         }
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="classOgre_1_1Quaternion.html#3f9320930fd5110028abf48c78a89622">00105</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">        </span>{
<a name="l00107"></a>00107             assert( i &lt; 4 );
<a name="l00108"></a>00108 
<a name="l00109"></a>00109             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00113"></a><a class="code" href="classOgre_1_1Quaternion.html#074aea0da7fabfde89d204a1f0f0121b">00113</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115             assert( i &lt; 4 );
<a name="l00116"></a>00116 
<a name="l00117"></a>00117             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00118"></a>00118         }
<a name="l00119"></a>00119 
<a name="l00121"></a><a class="code" href="classOgre_1_1Quaternion.html#ecce24dd0096766de0c96c13b195b197">00121</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123             <span class="keywordflow">return</span> &amp;w;
<a name="l00124"></a>00124         }
<a name="l00125"></a>00125 
<a name="l00127"></a><a class="code" href="classOgre_1_1Quaternion.html#b4b5bc328439a4f96d1b4b413fcf87cc">00127</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword">        </span>{
<a name="l00129"></a>00129             <span class="keywordflow">return</span> &amp;w;
<a name="l00130"></a>00130         }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         <span class="keywordtype">void</span> FromRotationMatrix (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kRot);
<a name="l00133"></a>00133         <span class="keywordtype">void</span> ToRotationMatrix (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kRot) <span class="keyword">const</span>;
<a name="l00134"></a>00134         <span class="keywordtype">void</span> FromAngleAxis (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis);
<a name="l00135"></a>00135         <span class="keywordtype">void</span> ToAngleAxis (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis) <span class="keyword">const</span>;
<a name="l00136"></a><a class="code" href="classOgre_1_1Quaternion.html#77b776c2f81d371549927b0f79478eb9">00136</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> ToAngleAxis (<a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp; dAngle, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis)<span class="keyword"> const </span>{
<a name="l00137"></a>00137             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> rAngle;
<a name="l00138"></a>00138             ToAngleAxis ( rAngle, rkAxis );
<a name="l00139"></a>00139             dAngle = rAngle;
<a name="l00140"></a>00140         }
<a name="l00141"></a>00141 <span class="preprocessor">#ifndef OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>        <span class="keyword">inline</span> <span class="keywordtype">void</span> FromAngleAxis (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis) {
<a name="l00143"></a>00143             FromAngleAxis ( <a class="code" href="classOgre_1_1Angle.html" title="Wrapper class which identifies a value as the currently default angle type, as defined...">Angle</a>(rfAngle), rkAxis );
<a name="l00144"></a>00144         }
<a name="l00145"></a>00145         <span class="keyword">inline</span> <span class="keywordtype">void</span> ToAngleAxis (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; rfAngle, Vector3&amp; rkAxis)<span class="keyword"> const </span>{
<a name="l00146"></a>00146             Radian r;
<a name="l00147"></a>00147             ToAngleAxis ( r, rkAxis );
<a name="l00148"></a>00148             rfAngle = r.valueAngleUnits();
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 <span class="preprocessor">#endif//OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>        <span class="keywordtype">void</span> FromAxes (<span class="keyword">const</span> Vector3* akAxis);
<a name="l00152"></a>00152         <span class="keywordtype">void</span> FromAxes (<span class="keyword">const</span> Vector3&amp; xAxis, <span class="keyword">const</span> Vector3&amp; yAxis, <span class="keyword">const</span> Vector3&amp; zAxis);
<a name="l00153"></a>00153         <span class="keywordtype">void</span> ToAxes (Vector3* akAxis) <span class="keyword">const</span>;
<a name="l00154"></a>00154         <span class="keywordtype">void</span> ToAxes (Vector3&amp; xAxis, Vector3&amp; yAxis, Vector3&amp; zAxis) <span class="keyword">const</span>;
<a name="l00156"></a>00156         Vector3 xAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00158"></a>00158         Vector3 yAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00160"></a>00160         Vector3 zAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classOgre_1_1Quaternion.html#6367b543cf0d073d893139dd503b4fbd">00162</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ)
<a name="l00163"></a>00163         {
<a name="l00164"></a>00164             w = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#f3424f1e07092c0ffe293d18b277a04f">w</a>;
<a name="l00165"></a>00165             x = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#32c5680516b41bc4ba3159bf4d4abaf1">x</a>;
<a name="l00166"></a>00166             y = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#a7328cd3883a92ee9c9322805d038f11">y</a>;
<a name="l00167"></a>00167             z = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#31ec84a931236554c0c17e37bf5ace97">z</a>;
<a name="l00168"></a>00168             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator+ (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator- (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00172"></a>00172         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00173"></a>00173         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator* </a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar) <span class="keyword">const</span>;
<a name="l00174"></a>00174         <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator* </a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar,
<a name="l00175"></a>00175             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ);
<a name="l00176"></a>00176         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator- () <span class="keyword">const</span>;
<a name="l00177"></a><a class="code" href="classOgre_1_1Quaternion.html#a20c618a3b4b67d22d2cfd64ba2c8f3b">00177</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00178"></a>00178 <span class="keyword">        </span>{
<a name="l00179"></a>00179             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Quaternion.html#32c5680516b41bc4ba3159bf4d4abaf1">x</a> == x) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1Quaternion.html#a7328cd3883a92ee9c9322805d038f11">y</a> == y) &amp;&amp;
<a name="l00180"></a>00180                 (rhs.<a class="code" href="classOgre_1_1Quaternion.html#31ec84a931236554c0c17e37bf5ace97">z</a> == z) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1Quaternion.html#f3424f1e07092c0ffe293d18b277a04f">w</a> == w);
<a name="l00181"></a>00181         }
<a name="l00182"></a><a class="code" href="classOgre_1_1Quaternion.html#aac827806910efa70a5deaa6d75bf3e1">00182</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00183"></a>00183 <span class="keyword">        </span>{
<a name="l00184"></a>00184             <span class="keywordflow">return</span> !<a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator==</a>(rhs);
<a name="l00185"></a>00185         }
<a name="l00186"></a>00186         <span class="comment">// functions of a quaternion</span>
<a name="l00187"></a>00187         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Dot (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;  <span class="comment">// dot product</span>
<a name="l00188"></a>00188         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Norm () <span class="keyword">const</span>;  <span class="comment">// squared-length</span>
<a name="l00190"></a>00190 <span class="comment"></span>        <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise(<span class="keywordtype">void</span>); 
<a name="l00191"></a>00191         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Inverse () <span class="keyword">const</span>;  <span class="comment">// apply to non-zero quaternion</span>
<a name="l00192"></a>00192         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> UnitInverse () <span class="keyword">const</span>;  <span class="comment">// apply to unit-length quaternion</span>
<a name="l00193"></a>00193         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Exp () <span class="keyword">const</span>;
<a name="l00194"></a>00194         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Log.html" title="Log class for writing debug/log data to files.">Log</a> () <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00196"></a>00196         <span class="comment">// rotation of a vector by a quaternion</span>
<a name="l00197"></a>00197         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector) <span class="keyword">const</span>;
<a name="l00198"></a>00198 
<a name="l00207"></a>00207         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getRoll(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00216"></a>00216         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getPitch(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00225"></a>00225         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getYaw(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;     
<a name="l00227"></a>00227         <span class="keywordtype">bool</span> equals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; tolerance) <span class="keyword">const</span>;
<a name="l00228"></a>00228         
<a name="l00229"></a>00229         <span class="comment">// spherical linear interpolation</span>
<a name="l00230"></a>00230         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Slerp (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP,
<a name="l00231"></a>00231             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> SlerpExtraSpins (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT,
<a name="l00234"></a>00234             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ,
<a name="l00235"></a>00235             <span class="keywordtype">int</span> iExtraSpins);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="comment">// setup for spherical quadratic interpolation</span>
<a name="l00238"></a>00238         <span class="keyword">static</span> <span class="keywordtype">void</span> Intermediate (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ0,
<a name="l00239"></a>00239             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ1, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ2,
<a name="l00240"></a>00240             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rka, <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkB);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242         <span class="comment">// spherical quadratic interpolation</span>
<a name="l00243"></a>00243         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Squad (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP,
<a name="l00244"></a>00244             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkA, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkB,
<a name="l00245"></a>00245             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247         <span class="comment">// normalised linear interpolation - faster but less accurate (non-constant rotation velocity)</span>
<a name="l00248"></a>00248         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> nlerp(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP, 
<a name="l00249"></a>00249             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251         <span class="comment">// cutoff for sine near zero</span>
<a name="l00252"></a><a class="code" href="classOgre_1_1Quaternion.html#2bfb8dc81611e22008261c3c04ed1227">00252</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ms_fEpsilon;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254         <span class="comment">// special values</span>
<a name="l00255"></a><a class="code" href="classOgre_1_1Quaternion.html#44f3c000c8f1ea2759c2e724e04bf86b">00255</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> ZERO;
<a name="l00256"></a><a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">00256</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> IDENTITY;
<a name="l00257"></a>00257 
<a name="l00258"></a><a class="code" href="classOgre_1_1Quaternion.html#31ec84a931236554c0c17e37bf5ace97">00258</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w, x, y, z;
<a name="l00259"></a>00259 
<a name="l00263"></a>00263         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00264"></a><a class="code" href="classOgre_1_1Quaternion.html#2a92fc4c7d55783c70ef6f633f3cac89">00264</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q )
<a name="l00265"></a>00265         {
<a name="l00266"></a>00266             o &lt;&lt; <span class="stringliteral">"Quaternion("</span> &lt;&lt; q.w &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; q.x &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; q.y &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; q.z &lt;&lt; <span class="stringliteral">")"</span>;
<a name="l00267"></a>00267             <span class="keywordflow">return</span> o;
<a name="l00268"></a>00268         }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     };
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="preprocessor">#endif </span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
